<?php

### GENERATES UNIQUE CODE ###################################################

	if (!function_exists('getUniqueCode')) :
		function getUniqueCode( $length = "" ) {
			$code = md5(uniqid(rand(), true));
		 	if ($length != "") return substr($code, 0, $length); else return $code;
		}
	endif;
	
### SANITIZE - A variable cleaning function #################################

function clean_var($variable) {
	return strip_tags(stripslashes(trim(rtrim($variable))));
}

### Break text into chunks for direct messages

function blow_chunks_on_twitter( $content ) {

	$content = trim(implode(' - ', $content)." - Sent via Jigowatt WordPress AJAX Contact Forms");
	
	$content = chunk_split( $content, 134, "<!--Break_ME-->" );
	
	$content = explode( "<!--Break_ME-->", $content );
	
	$content = array_filter($content);
	
	// Prepend and append each chunk with ...
	$content = array_map('add_dots_to_array', $content);
	
	// Remove Last ...
	$content[(sizeof($content)-1)] = "...".str_replace('...','',$content[(sizeof($content)-1)]);
		
	// Remove First ...
	$content[0] = str_replace('...','',$content[0])."...";

	// Send in reverse order so it makes sense in Twitter
	$content = array_reverse($content);
	
	return $content;
	
}

function add_dots_to_array( $string ) {
	return '...'.$string.'...';
}

###  Twitter Direct Message CURL function ###################################################

function twittermessage($user, $message, $consumer_key, $consumer_secret, $token, $secret) { // Twitter Direct Message function, do not edit.
	
	require_once('twitter/EpiCurl.php');
    require_once('twitter/EpiOAuth.php');
    require_once('twitter/EpiTwitter.php');

	$Twitter = new EpiTwitter($consumer_key, $consumer_secret);
    $Twitter->setToken($token, $secret);

    $direct_message = $Twitter->post_direct_messagesNew( array('user' => $user, 'text' => $message) );
    $tweet_info = $direct_message->responseText;
    
}

### PROCESS A POSTED FORM ###################################################

function process_jigowatt_form( $form ) {

	if(!$_POST || !$form) return;
		
		global $found_shortcodes;
		
		$posted = array();
		$error = '';
		$headers = '';

		/* Scan the form's code for shortcodes and find out which are required */
		$form_code = strip_tags($form->form_code);
		
		$found_shortcodes = array();
		$comments = array();
		
		add_shortcode('input_box', 'jigowatt_find_shortcode');
		add_shortcode('select_box', 'jigowatt_find_shortcode');
		add_shortcode('message_box', 'jigowatt_find_shortcode');
		
		do_shortcode($form_code);
		
		remove_shortcode('input_box');
		remove_shortcode('select_box');
		remove_shortcode('message_box');
		
		foreach ($found_shortcodes as $field) :
			
			if ($field['name']) :
			
				if ($field['type']=='submit') continue; // no need to process submit boxes
			
				$posted[$field['name']] = $_POST['jigowatt_'.$field['name']];
				
				$comments[] = "".ucwords($field['name']).": ".PHP_EOL."\t\t".stripslashes($posted[$field['name']]);
				
				// Required field
				if ($field['required']=="true" && empty($posted[$field['name']])) :
					$error .= '<li>&ldquo;'.ucwords($field['name']).'&rdquo; '.__('is required','jigowatt').'.</li>';
				endif;
				
				// Types
				if ($field['type']) :
					switch ($field['type']) :
						case "email" :
							if(!is_email($posted[$field['name']])) $error .= __('<li>You have entered an invalid e-mail address.</li>','jigowatt');
							$headers = "From: ".$posted[$field['name']]."\r\n\\";
						break;
					endswitch;
				endif;
			endif;
		
		endforeach;
		
		$posted = array_map('clean_var', $posted);
		
		// Captcha
		if ( isset($_POST['jigowatt_image_captcha']) ) :
			
			if (isset($_POST['jigowatt_image_captcha'])) :
		    	$posted_verify   = trim(stripslashes($_POST['jigowatt_image_captcha']));
		   		$posted_verify   = md5($posted_verify);
		   	else :
		   		$posted_verify = '';
		   	endif;

			$session_verify = $_SESSION['verify'];
			
			if (empty($session_verify)) $session_verify = $_COOKIE['verify'];
			
			if($session_verify != $posted_verify) {
	    		$error .= __('<li>The verification code you entered is incorrect.</li>','jigowatt');
	    	}
			
		endif;
			
		if($error != '') { 
			echo '<div class="error_message">'.__('Attention! Please correct the errors below and try again.','jigowatt').'';
			echo '<ul class="error_messages">' . $error . '</ul>';
			echo '</div>';
		
		} else {
		
		$address = $form->form_email;
				
		$e_subject = __('You\'ve been contacted via the form "','jigowatt').$form->form_name.__('" on ','jigowatt').get_bloginfo('name').'.';
		
		// Advanced Configuration Option.
		// You can change this if you feel that you need to.
		// Developers, you may wish to add more fields to the form, in which case you must be sure to add them here.
				
		$msg  = __("You have been contacted via ",'jigowatt').get_bloginfo('name').__(" - their message is as follows.",'jigowatt') . PHP_EOL . PHP_EOL;
		$msg .= implode(PHP_EOL, $comments) . PHP_EOL . PHP_EOL;
		$msg .= "-------------------------------------------------------------------------------------------\r\n";
		$msg .= "This message was sent to you via Jigowatt WordPress AJAX Contact Forms";
		
		$msg = wordwrap( $msg, 70 );
		
		$twitter_data = unserialize($form->twitter_data);
				 		
		if(isset($twitter_data['twitter_name']) && isset($twitter_data['twitter_ckey']) && isset($twitter_data['twitter_csecret']) && isset($twitter_data['twitter_token']) && isset($twitter_data['twitter_secret'])) { 
			
			
			// Spilt into smaller messages if its long
			$twitter_msg = blow_chunks_on_twitter($comments);
			foreach ($twitter_msg as $t) :
				
				twittermessage($twitter_data['twitter_name'], $t, $twitter_data['twitter_ckey'], $twitter_data['twitter_csecret'], $twitter_data['twitter_token'], $twitter_data['twitter_secret']);
							
			endforeach;
		
		}
		
		if( wp_mail($address, $e_subject, $msg, $headers) ) {
		
			 echo "<fieldset>";			
			 echo "<div id='success_page'>";
			 echo __("<h1>Email Sent Successfully.</h1>",'jigowatt');
			 echo __("<p>Thank you, your message has been submitted to us.</p>",'jigowatt');
			 echo "</div>";
			 echo "</fieldset>";
		 		 
		 } else {
		 
			 echo __('ERROR sending message!','jigowatt');
		 
		 }
	}
}