<?php
add_shortcode('jigowatt_form', 'jigowatt_form_shortcode');
add_shortcode('input_box', 'jigowatt_input_box_shortcode');
add_shortcode('select_box', 'jigowatt_select_box_shortcode');
add_shortcode('message_box', 'jigowatt_message_box_shortcode');
add_shortcode('captcha', 'jigowatt_captcha_shortcode');

### FIND SHORTCODE - USED WHEN PROCESSING FORMS ##############################

function jigowatt_find_shortcode( $atts ) {
	
	global $found_shortcodes;
	
	if (!is_array($found_shortcodes)) $found_shortcodes = array();
	
	extract(shortcode_atts(array(
		'name' => '',
		'id' => '',
		'value' => '',
		'required' => 'true',		
		'type' => 'text'
	), $atts));
	
	$found_shortcodes[] = array(
		'name' => $name,
		'id' => $id,
		'value' => $value,
		'required' => $required,		
		'type' => $type
	);
	
}

### FORM DISPLAY SHORTCODE ###################################################

function jigowatt_form_shortcode( $atts ) {
	
	global $wpdb, $jigowatt_vars;
	
	extract(shortcode_atts(array(
		'id' => '1'	// Default to first form found
	), $atts));
	
	$output = '';

	if (!is_numeric($id) || $id < 1 ) return '[Form does not exist]';
	
	// Get the form from the database
	$sql_form = sprintf("SELECT * FROM %s WHERE ID = %s LIMIT 1;",
		$wpdb->escape( $jigowatt_vars['form_database'] ),
		$wpdb->escape( $id )
	);	
	$form = $wpdb->get_row($sql_form);
	
	if (!$form) return '[Form does not exist]';
	
	$form_code = $form->form_code;
	$form_code = do_shortcode($form_code);
	
	// Object start so we can grab the form and stick it in a variable
	ob_start();
	
	?>
	<div id="jigowatt_form"><?php process_jigowatt_form($form); ?><div id="message"></div><form id="jigowatt_form_<?php echo $id; ?>" name="<?php echo $id; ?>" method="post" action="<?php
    	global $post;
    	if (is_single() || is_page()) :
    		echo get_permalink($post->ID);
    	else :
    		$pageURL = 'http';
    		if ($_SERVER["HTTPS"] == "on") $pageURL .= "s";
    		$pageURL .= "://";
    		if ($_SERVER["SERVER_PORT"] != "80") $pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
    		else $pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
    		echo $pageURL;
    	endif;
    ?>"><?php echo $form_code; ?></form></div><?php
    
    add_action('wp_footer', 'jigowatt_form_shortcode_footer');
    add_filter('the_content', 'remove_label_br', 100);
    
    $output = ob_get_clean();

	return $output;
}

function remove_label_br($content) {
	$content = str_replace('</label><br />','</label>',$content);
	return $content;
}

function jigowatt_form_shortcode_footer() {
	global $jigowatt_vars;
	?>
	<script type="text/javascript">
	/* <![CDATA[ */
	    jQuery(function(){
			jQuery('#jigowatt_form form').submit(function(){
				var action = '<?php echo $jigowatt_vars['plugin_url']; ?>ajax_submit.php?formid=' + jQuery(this).attr('name');
				jQuery('#jigowatt_form input[type="submit"]').attr('disabled','disabled').after('<img src="<?php echo $jigowatt_vars['plugin_url']; ?>assets/ajax-loader.gif" class="loader" />');
				jQuery("#message").slideUp(750,function() {
					jQuery('#message').hide();			
					jQuery.post(action, 
						jQuery('#jigowatt_form form').serializeArray(),
						function(data){
							jQuery('#message').html(data).slideDown('slow');
							jQuery('#jigowatt_form img.loader').fadeOut('fast',function(){jQuery(this).remove()});
							jQuery('#jigowatt_form input[type="submit"]').attr('disabled',''); 
							if( jQuery('#success_page').size() > 0 ) jQuery('#jigowatt_form form').slideUp('slow');
						}
					);
				});
				return false; 
			});
		});
	/* ]]> */
	</script>
	<?php
}

### INPUT BOX SHORTCODES ###################################################

function jigowatt_input_box_shortcode( $atts ) {
	
	extract(shortcode_atts(array(
		'name' => '',
		'id' => '',
		'value' => '',
		'required' => 'true',		
		'type' => 'text'
	), $atts));
	
	$output = '';
	$classes = array();
	
	if (!$id) $id = $name;
	
	if ($required!=='false') :
		$classes[] = 'required';
	endif;
	
	switch ($type) :
		case 'submit' :
		
			if ( !$value ) $value = 'Submit';
			
			$output = '<input type="submit" value="'.$value.'" id="'.$id.'" class="submit" />';
		break;
		case 'email' :
			
			$classes[] = 'email';
			
			$name = 'jigowatt_'.$name;
			
			$output = '<input type="text" value="';
			
			if ( isset($_POST[$name]) ) :
				$output .= $_POST[$name];
			elseif ( $value ) :
				$output .= $value;
			endif;
			
			$output .= '" name="'.$name.'" id="'.$id.'" class="input email-input';
			if ($required!=='false') $output .= ' required';
			$output .= '" />';
		break;
		default :
		
			$name = 'jigowatt_'.$name;
			
			$output = '<input type="text" value="';
			
			if ( isset($_POST[$name]) ) :
				$output .= $_POST[$name];
			elseif ( $value ) :
				$output .= $value;
			endif;
			
			$output .='" name="'.$name.'" id="'.$id.'" class="input';
			if ($required!=='false') $output .= ' required';
			$output .= '" />';
		break;
	endswitch;

	return $output;
}

function jigowatt_select_box_shortcode( $atts ) {
	
	extract(shortcode_atts(array(
		'name' => '',
		'id' => '',
		'value' => '',		
		'values' => ''
	), $atts));
	
	if (!$id) $id = $name;
	
	$name = 'jigowatt_' . $name;
	
	if ( isset($_POST[$name]) ) :
		$value = $_POST[$name];
	endif;
	
	$output = '';
	
	$output = '<select name="'.$name.'" id="'.$id.'" class="submit">';
	
	if ($values) :
		$values = explode('|', $values);
		foreach ($values as $option_value) :
			$output .= '<option ';
			if ($value==$option_value) $output .= 'selected="selected"';
			$output .= '>'.$option_value.'</option>';
		endforeach;
	endif;
	
	$output .= '</select>';

	return $output;
}

function jigowatt_message_box_shortcode( $atts ) {
	
	extract(shortcode_atts(array(
		'name' => '',
		'id' => '',
		'value' => '',
		'required' => 'false',
	), $atts));
	
	if (!$id) $id = $name;
	
	$name = 'jigowatt_' . $name;
	
	if ( isset($_POST[$name]) ) :
		$value = $_POST[$name];
	endif;

	$output = '<textarea name="'.$name.'" id="'.$id.'" class="textarea" rows="5" cols="25">'.$value.'</textarea>';

	return $output;
	
}

function jigowatt_captcha_shortcode( $atts ) {
	
	global $jigowatt_vars;
		
	// Image based captcha
	$output = '<img alt="Verification code" src="'.$jigowatt_vars['plugin_url'].'verify/image.php" class="captcha_image" /> <input type="text" value="" name="jigowatt_image_captcha" id="captcha" class="captcha input required" title="'.__('This confirms you are a human user and not a spam-bot.','jigowatt').'" />';
	
	return $output;
	
}